-- bags.lua
-- written by Habna


function frmBagInfos()
	frmBI = true;
	tbagspack = Backpack;
	SelCN = PN;
	import (AppClassD.."ComboBox");
	BagsCB = HabnaPlugins.HugeBag.Class.ComboBox();
	
	-- **v Set some window stuff v**
	wBagInfos = Turbine.UI.Lotro.Window();
	wBagInfos:SetText( L["BIh"] );
	wBagInfos:SetPosition( BIWLeft, BIWTop );
	wBagInfos:SetSize( 390, 492 );
	wBagInfos:SetWantsKeyEvents( true );
	wBagInfos:SetVisible( true );
	--wBagInfos:SetZOrder( 2 );
	--wBagInfos:Activate();

	wBagInfos.KeyDown = function( sender, args )
		if ( args.Action == Turbine.UI.Lotro.Action.Escape ) then
			wBagInfos:Close();
		elseif ( args.Action == 268435635 ) or ( args.Action == 268435579 ) then -- Hide if F12 key is press or reposition UI
			wBagInfos:SetVisible( not wBagInfos:IsVisible() );
		end
	end

	wBagInfos.MouseMove = function( sender, args )
		if BagsCB.dropped then
			local height = BagsCB:GetHeight();
			local x, y = BagsCB:GetParent():PointToScreen(BagsCB:GetPosition());
			BagsCB.dropDownWindow:SetPosition(x, y + height + 2);
		end
	end

	wBagInfos.MouseUp = function( sender, args )
		HBsettings.BagInfos.L = string.format("%.0f", wBagInfos:GetLeft());
		HBsettings.BagInfos.T = string.format("%.0f", wBagInfos:GetTop());
		BIWLeft, BIWTop = wBagInfos:GetPosition();
		SaveSettings( false );
	end

	wBagInfos.Closing = function( sender, args ) -- Function for the Upper right X icon
		BagsCB.dropDownWindow:SetVisible(false);
		wBagInfos:SetWantsKeyEvents( false );
		option_bags:SetEnabled( true );
		RemoveCallback( tbagspack, "ItemAdded" );
		RemoveCallback( tbagspack, "ItemRemoved" );
		wBagInfos = nil;
		frmBI = nil;
	end
	-- **^
	-- **v Create drop down box v**
	BagsCB:SetParent( wBagInfos );
	BagsCB:SetSize( 159, 19 );
	BagsCB:SetPosition( 15, 35 );

	BagsCB.ItemChanged = function () -- The event that's executed when a menu item is clicked.
		SelCN = BagsCB.label:GetText();
		CountBagsItems();
	end

	CreateBagsComboBox();
	-- **^
	-- **v Set the itemlistbox border v**
	wBagInfos.ListBoxBorder = Turbine.UI.Control();
	wBagInfos.ListBoxBorder:SetParent( wBagInfos );
	wBagInfos.ListBoxBorder:SetPosition( 15, 60 );
	wBagInfos.ListBoxBorder:SetSize( wBagInfos:GetWidth()-30, 390 );
	wBagInfos.ListBoxBorder:SetBackColor( Color["grey"] );
	wBagInfos.ListBoxBorder:SetVisible( true );
	-- **^
	-- **v Set the itemlistbox v**
	wBagInfos.ListBox = Turbine.UI.ListBox();
	wBagInfos.ListBox:SetParent( wBagInfos );
	wBagInfos.ListBox:SetPosition( wBagInfos.ListBoxBorder:GetLeft() + 2, wBagInfos.ListBoxBorder:GetTop() + 2 );
	wBagInfos.ListBox:SetSize( wBagInfos.ListBoxBorder:GetWidth() - 4, wBagInfos.ListBoxBorder:GetHeight() - 4 );
	wBagInfos.ListBox:SetMaxItemsPerLine( 1 );
	wBagInfos.ListBox:SetOrientation( Turbine.UI.Orientation.Horizontal );
	wBagInfos.ListBox:SetBackColor( Turbine.UI.Color( 1, 0, 0, 0 ) );
	-- **^
	-- **v Set the scrollbar v**
	wBagInfos.ListBoxScrollBar = Turbine.UI.Lotro.ScrollBar();
	wBagInfos.ListBoxScrollBar:SetParent( wBagInfos );
	wBagInfos.ListBoxScrollBar:SetOrientation( Turbine.UI.Orientation.Vertical );
	wBagInfos.ListBox:SetVerticalScrollBar( wBagInfos.ListBoxScrollBar );
	wBagInfos.ListBoxScrollBar:SetPosition( wBagInfos:GetWidth()-28, wBagInfos.ListBox:GetTop() + 2 );
	wBagInfos.ListBoxScrollBar:SetSize( 10, wBagInfos.ListBox:GetHeight() - 2 );
	-- **^
	-- **v Delete character infos button v**
	wBagInfos.ButtonDelete = Turbine.UI.Lotro.Button();
	wBagInfos.ButtonDelete:SetParent( wBagInfos );
	wBagInfos.ButtonDelete:SetText( L["ButDel"] );
	wBagInfos.ButtonDelete:SetSize( wBagInfos.ButtonDelete:GetTextLength() * 11, 15 ); --Auto size with text lenght
	wBagInfos.ButtonDelete:SetPosition( wBagInfos:GetWidth()/2 - wBagInfos.ButtonDelete:GetWidth()/2, wBagInfos.ListBox:GetTop()+ wBagInfos.ListBox:GetHeight()+5 );

	wBagInfos.ButtonDelete.Click = function( sender, args )
		PlayerBags[SelCN] = nil;
		SavePlayerBags();
		write(SelCN .. L["BID"]);
		SelCN = PN;
		BagsCB.selection = -1;
		CreateBagsComboBox();
		CountBagsItems();
	end
	-- **^
	
	AddCallback(tbagspack, "ItemAdded", 
		function(sender, args)
		if frmBI then
			bagspackCount = 0;
			if SelCN == PN then
				SavePlayerBags();
				bagspackCount = 0;
				if PlayerBags[PN] ~= nil then for k, v in pairs(PlayerBags[PN]) do bagspackCount = bagspackCount + 1; end end
				SetBagsPack(SelCN);
			end
		end
	end);

	--**v Workaround for the ItemRemoved that fire before the backpack was updated (Turnine API issue) v**
	BIItemRemovedTimer = Turbine.UI.Control();
	BIItemRemovedTimer.Update = function( sender, args )
		BIItemRemovedTimer:SetWantsUpdates( false );
		if frmBI then
			bagspackCount = 0;
			if SelCN == PN then
				SavePlayerBags();
				bagspackCount = 0;
				if PlayerBags[PN] ~= nil then for k, v in pairs(PlayerBags[PN]) do bagspackCount = bagspackCount + 1; end end
				SetBagsPack(SelCN);
			end
		end
	end

	AddCallback(tbagspack, "ItemRemoved", function(sender, args) BIItemRemovedTimer:SetWantsUpdates( true ); end); --Workaround

	CountBagsItems();
end

function CountBagsItems()
	bagspackCount = 0;
	if SelCN == PN then bagspackCount = tbagspack:GetSize();
	else for k, v in pairs(PlayerBags[SelCN]) do bagspackCount = bagspackCount + 1; end end
	SetBagsPack(SelCN);
end

function CreateBagsComboBox()
	-- **v Create an array of character name, sort it, then use it as a reference - label & DropDown box v**
	local newt = {}
	for i in pairs(PlayerBags) do
		if string.sub( i, 1, 1 ) == "~" then PlayerBags[i] = nil; else table.insert(newt, i); end --Delete session play character
	end
	table.sort(newt);
	BagsCB.listBox:ClearItems();
	for k,v in pairs(newt) do
		BagsCB:AddItem(v, k);
		if v == PN then BagsCB:SetSelection(k); end
	end
	-- **^
end

function SetBagsPack(n)
	wBagInfos.ListBox:ClearItems();
	itemCtl = {};
	titem = nil;

	for i = 1, bagspackCount do
		-- Item control
		itemCtl[i] = Turbine.UI.Control();
		itemCtl[i]:SetSize( wBagInfos.ListBox:GetWidth()-12, 34 );
		--if string.len(i / 2) <= 2 then itemCtl[i]:SetBackColor( Color["grey"] ); end --debug purpose

		if n == PN then
			wBagInfos.ButtonDelete:SetEnabled( false );
			titem = tbagspack:GetItem(i);

			-- Item Background/Underlay/Shadow/Image
			local itemBG = Turbine.UI.Lotro.ItemControl( titem );
			itemBG:SetParent( itemCtl[i] );
			itemBG:SetSize( 34, 34 );
			itemBG:SetPosition( -2, -2 );
		else
			wBagInfos.ButtonDelete:SetEnabled( true );
			titem = PlayerBags[n][tostring(i)];

			-- Item Background/Underlay/Shadow/Image
			local itemBG = Turbine.UI.Control();
			itemBG:SetParent( itemCtl[i] );
			itemBG:SetSize( 32, 32 );
			itemBG:SetPosition( 1, 1 );
			itemBG:SetBackground(tonumber(PlayerBags[n][tostring(i)].B));
			itemBG:SetBlendMode( Turbine.UI.BlendMode.Overlay );
		
			local itemU = Turbine.UI.Control();
			itemU:SetParent( itemCtl[i] );
			itemU:SetSize( 32, 32 );
			itemU:SetPosition( 1, 1 );
			if PlayerBags[n][tostring(i)].U ~= "0" then itemU:SetBackground(tonumber(PlayerBags[n][tostring(i)].U)); end
			itemU:SetBlendMode( Turbine.UI.BlendMode.Overlay );

			local itemS = Turbine.UI.Control();
			itemS:SetParent( itemCtl[i] );
			itemS:SetSize( 32, 32 );
			itemS:SetPosition( 1, 1 );
			if PlayerBags[n][tostring(i)].S ~= "0" then itemS:SetBackground(tonumber(PlayerBags[n][tostring(i)].S)); end
			itemS:SetBlendMode( Turbine.UI.BlendMode.Overlay );

			local item = Turbine.UI.Control();
			item:SetParent( itemCtl[i] );
			item:SetSize( 32, 32 );
			item:SetPosition( 1, 1 );
			item:SetBackground(tonumber(PlayerBags[n][tostring(i)].I));
			item:SetBlendMode( Turbine.UI.BlendMode.Overlay );

			-- Item Quantity
			local itemQTE = Turbine.UI.Label();
			itemQTE:SetParent( itemCtl[i] );
			itemQTE:SetSize( 32, 15 );
			itemQTE:SetPosition( -3, 15 );
			itemQTE:SetFont( Turbine.UI.Lotro.Font.Verdana12 );
			itemQTE:SetFontStyle( Turbine.UI.FontStyle.Outline );
			itemQTE:SetOutlineColor( Color["black"] );
			itemQTE:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleRight );
			itemQTE:SetBackColorBlendMode( Turbine.UI.BlendMode.Overlay );
			itemQTE:SetForeColor( Color["nicegold"] );
			itemQTE:SetText(tonumber(PlayerBags[n][tostring(i)].N));
		end

		-- Item name
		local itemLbl = Turbine.UI.Label();
		itemLbl:SetParent( itemCtl[i] );
		itemLbl:SetSize( itemCtl[i]:GetWidth() - 35, 35 );
		itemLbl:SetPosition( 37, 2 );
		itemLbl:SetFont( Turbine.UI.Lotro.Font.TrajanPro16 );
		itemLbl:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
		itemLbl:SetBackColorBlendMode( Turbine.UI.BlendMode.Overlay );
		itemLbl:SetForeColor( Color["white"] );

		if titem ~= nil then
			if n == PN then itemLbl:SetText( titem:GetName() );
			else itemLbl:SetText( titem.T ); end
			wBagInfos.ListBox:AddItem( itemCtl[i] );
		end
	end

	-- Set window title
	--wBagInfos:SetText( L["MBI"] .. " - " .. L["VTFree"] .. ( bagspackSize - bagspackCount ) .. L["VTUsed"] .. bagspackCount .. L["VTMax"] .. bagspackSize );
end